#ifndef VNET_YARP_ONLY_HH_
#define VNET_YARP_ONLY_HH_ 

#include <string>

#include <yarp/os/all.h>

namespace vnet {
	namespace yarp {
		template <typename T>
		class Reader {
			private:
				typedef ::yarp::os::BufferedPort<T>  type;
				type port;

			public:
				Reader(const std::string& uri) : port() {
					port.open(uri.c_str());
				}
				bool read(T& value, bool wait) {
					T* res = port.read(wait);
					if (res == NULL)
						return false;

					value = *res;
					return true;
				}
		};


		template <typename T>
		class Writer {
			private:
				typedef ::yarp::os::BufferedPort<T> type;
				type port;

			public:
				Writer(const std::string& local_uri, const std::string& remote_uri) :
					port()
				{
					port.open(local_uri.c_str());
					port.addOutput(remote_uri.c_str());
				}

				T& prepare() { return port.prepare(); }

				bool write() { port.writeStrict(); return true; }
		};
	}
}

#endif
