#include <vnet_yarp.hh>
#include <cassert>

int main()
{
	yarp::os::Network::init();

	vnet::yarp::Reader<yarp::os::Bottle> reader("/pipo/in");
	vnet::yarp::Writer<yarp::os::Bottle> writer("/pipo/out", "/pipo/in");

	yarp::os::Bottle& bottle = writer.prepare();
	bottle.addInt(10);
	bottle.addInt(20);
	assert(writer.write());

	yarp::os::Bottle bottle_r;
	bool ok = reader.read(bottle_r, true);
	assert(ok == true);
	assert(bottle_r.size() == 2);
	assert(bottle_r.get(0).asInt() == 10);
	assert(bottle_r.get(1).asInt() == 20);

	yarp::os::Network::fini();
}
